Builtin modules

From FreeCAD Documentation

This page presents more in-depth information over the built-in FreeCAD modules, and what are the functions and properties availible to you. This page is not a complete list of all the contents of these modules, and, because of the fast evolution of FreeCAD, the information presented here might be slightly outdated, but it should give you a good overview of the possibilities. For complete list of the modules content, use the dir(module) function in the interpreter.

The FreeCAD module

This is the principal (root) module of FreeCAD. It can also be called by "App" from the FreeCAD interpreter. It contains everything that is needed to manipulate documents and their contents (objects).

Example:

import FreeCAD
print FreeCAD.listDocuments()
mydoc = FreeCAD.activeDocument()


ConfigDump( )

Description: Prints a dictionnnary containing all the FreeCAD configuration environment.

Returns:

ConfigGet([string])

Description: Returns the value of the given key. If no key is given, the complete configuration is returned

Returns: A string.

ConfigSet(string, string)

Description: Set the given key (first string) to the given value (second string).

Returns:

Version( )

Description: Prints the FreeCAD version.

Returns:

activeDocument( )

Description:

Returns: Return the active document or None if there is no active document.

addExportType(string, string)

Description: Adds a new export file type to FreeCAD. The first string must be formatted like this example: "Word Document (*.doc)". The second string is the name of a python script/module containing an export() function.

Returns:

addImportType(string, string)

Description: Adds a new import file type to FreeCAD, works the same way as addExportType, the handling python module must contain an open() and/or an import() function.

Returns:

closeDocument(Document name)

Description: Closes the given document

Returns:

getDocument(Document name)

Description: Returns a document or raise an exception if there is no document with the given name.

Returns:

getExportType(string)

Description: Returns the name of the module that can export the specified filetype.

Returns: A string.

getImportType(string)

Description: Returns the name of the module that can import the specified filetype.

Returns: A string.

listDocuments( )

Description: Returns a list of names of all documents.

Returns: A list of names.

newDocument([string])

Description: Creates and returns a new document with a given name. The document name must be unique, which is checked automatically. If no name is supplied, the document will be named "Untitled".

Returns: The newly created document.

open(string)

Description: See openDocument

Returns:

openDocument(filepath)

Description: Creates and returns a document and load a project file into the document. The string argument must point to an existing file. If the file doesn't exist or the file cannot be loaded an I/O exception is thrown. In this case the created document is kept, but will be empty.

Returns: The opened FreeCAD Document.

setActiveDocument(Document name)

Description: Set the active document by its name.

Returns:

Base

The Base module is contained inside the FreeCAD module and contains constructors for different types of objects heavily used in FreeCAD.

BoundBox([Xmin,Ymin,Zmin,Xmax,Ymax,Zmax] ) or ( Tuple, Tuple ) or ( Vector, Vector)

Description: Creates a bounding box. A bounding box is an orthographic cube which is a way to describe outer boundaries. You get a bounding box from a lot of 3D types. It is often used to check if a 3D entity lies in the range of another object. Checking for boundig interference first can save a lot of computing time!

Matrix( )

Description: Creates a 4x4 matrix, that can be used to apply transformations to objects.

Vector(x,y,z)

Description: Creates a FreeCAD 3D vector, representing a 3D point or a direction.

Vectors

Vectors are used everywhere in FreeCAD.

Example:

v=FreeCAD.Vector()
v=FreeCAD.Vector(1,0,0)
v=FreeCAD.Base.Vector()
v2 = FreeCAD.Vector(3,2,-5)
v3 = v.add(v2)
print v3.Length
Length

Returns: returns the length of the vector.

add(Vector)

Description: adds another vector to this one

Returns: the sum of both vectors.

cross(Vector)

Description:

Returns: the crossproduct between two vectors.

distanceToLine(Vector1,Vector2)

Description:

Returns: the distance between the vector and a line between Vector1 and Vector2.

distanceToPlane(Vector1,Vector2)

Description:

Returns: the distance between the vector and a plane defined by a point and a normal.

dot(Vector)

Description:

Returns: the dot product between 2 vectors.

getAngle(Vector)

Description:

Returns: the angle in radians between 2 vectors.

multiply(Float)

Description: multiplies (scales) a vector by the given factor

Returns: nothing.

normalize( )

Description: normalizes a vector (sets its length to 1.0).

Returns: nothing.

projectToLine(Vector1,Vector2)

Description: projects the vector on a line between Vector1 and Vector2.

Returns: nothing.

projectToPlane(Vector1,Vector2)

Description: projects the vector on a plane defined by a point and a normal.

Returns: nothing.

scale(Float,Float,Float)

Description: Same as multiply but lets specify different values for x, y and z directions.

Returns: nothing.

sub(Vector)

Description: subtracts another vector from the first one.

Returns: the resulting vector.

x

Returns: the x coordinate of a vector.

y

Returns: the y coordinate of a vector.

z

Returns: the z coordinate of a vector.

Matrixes

4x4 Matrixes are used everywhere throughout FreeCAD and can be created by one of the following manners:

m=FreeCAD.Matrix()
m=FreeCAD.Base.Matrix()
print m.A21()
A( )

Description:

Returns: all the matrix elements.

A11( )

Description:

Returns: a matrix element.

A12( )

Description:

Returns: a matrix element.

A13( )

Description:

Returns: a matrix element.

A14( )

Description:

Returns: a matrix element.

A21( )

Description:

Returns: a matrix element.

A22( )

Description:

Returns: a matrix element.

A23( )

Description:

Returns: a matrix element.

A24( )

Description:

Returns: a matrix element.

A31( )

Description:

Returns: a matrix element.

A32( )

Description:

Returns: a matrix element.

A33( )

Description:

Returns: a matrix element.

A34( )

Description:

Returns: a matrix element.

A41( )

Description:

Returns: a matrix element.

A42( )

Description:

Returns: a matrix element.

A43( )

Description:

Returns: a matrix element.

A44( )

Description:

Returns: a matrix element.

determinant(Float)

Description: Computes the determinant of the matrix

Returns: the matrix determinant.

inverse( )

Description: Computes the inverse matrix, if possible

Returns: a Matrix

invert( )

Description: Computes the inverse matrix, if possible

Returns: a Matrix

move(Vector)

Description: Moves the matrix along the vector

Returns: nothing.

multiply(Matrix or Vector)

Description: Multiplies a matrix or vector with this matrix

Returns: nothing.

rotateX(Float)

Description: rotates the matrix around X axis (in radians)

Returns: nothing.

rotateY(Float)

Description: rotates the matrix around Y axis (in radians)

Returns: nothing.

rotateZ(Float)

Description: rotates the matrix around Z axis (in radians)

Returns: nothing.

scale(Vector)

Description: Scales the matrix with the vector

Returns: nothing.

transform(Vector or Matrix)

Description: returns the dot product of the two vectors

Returns:

unity( )

Description: makes this matrix to unity

Returns: nothing.

Console module

This module is contained inside the FreeCAD module and contains methods to send text to FreeCAD's output console and status bar. The messages will have different color if they are message, warning or error. Example:

import FreeCAD
FreeCAD.PrintMessage("Hello World!\n")
GetStatus("Log" or "Msg" or "Wrn" or "Err")

Description: Get the status for either Log, Msg, Wrn or Error for an observer

Returns: a status string.

PrintError(string)

Description: Prints an error message to the output

Returns: nothing

PrintLog(string)

Description: Prints a log message to the output

Returns: nothing

PrintMessage(string)

Description: Prints a message to the output

Returns: nothing

PrintWarning(string)

Description: Prints a warning to the output

Returns: nothing

SetStatus(string)

Description: Set the stats for either Log, Msg, Wrn or Error for an observer

Returns:

The FreeCADGui Module

This module is the counterpart of the FreeCAD module. It contains everything related to the User interface and the 3D views. Example:

import FreeCADGui
doc = FreeCADGui.activeDocument()
activateWorkbench(string)

Description: Activates a workbench by name

Returns: nothing

activeDocument( )

Description:

Returns: the active document or None if no one exists

activeWorkbench( )

Description:

Returns: the active workbench object

addCommand(string, object)

Description: Adds a FreeCAD command. String is the name of the command and object is a classname defining the command

Returns:

addIcon(string, string or list)

Description: Adds an icon as file name or in XPM format to the system

Returns:

addIconPath(string)

Description: Add a new path to the system where to find icon files

Returns:

addPreferencePage(string,string)

Description: Adds a UI form to the preferences dialog. The first argument specifies the file name and the second specifies the group name

Returns:

addWorkbench(string, object)

Description: Adds a workbench under a defined name. The string is the workbench name and the object is a classname defining the workbench

Returns:

createDialog(string)

Description: Opens a UI file

Returns:

getDocument(string)

Description: Gets a document by its name

Returns: the document

getWorkbench(string)

Description: Gets a workbench by its name

Returns: the workbench

insert(string)

Description: Open a macro, Inventor or VRML file

Returns: the document

listWorkbenches( )

Description: Shows a list of all workbenches

Returns: a list

open(string)

Description: Opens a macro, Inventor or VRML file

Returns: the openend document

removeWorkbench(string)

Description: Removes a workbench by name

Returns:

runCommand(string)

Description: Runs a FreeCAD command by name

Returns:

updateGui( )

Description: Updates the main window and all its windows

Returns:

Selection sub-module

The selection submodule is part of the FreeCADGui module.

  • addSelection(object) - Add an object to the selection
  • clearSelection([string]) - Clear the selection to the given document name. If no document is given the complete selection is cleared.
  • getSelection([string]) - Return a list of selected objects for a given document name. If no document is given the complete selection is returned.
  • isSelected(object) - Check if a given object is selected
  • removeSelection(object) - Remove an object from the selection

Document Objects

Being parametric, document objects in FreeCAD can have a lot of additional properties, but these are the basic ones, present in every FreeCAD Document Object. Objects can be retrieved simply by their name:

myObj = FreeCAD.ActiveDocument.myObjectName
  • Object.Content - Return an XML representation of the properties of an object.
  • Object.Label - Gets/sets the objects label. The string can be unicode.
  • Object.Name - Returns the unique name of an object
  • Object.Placement - Gets/sets the Placement of an object. A placement defines an orientation (rotation) and a position (base) in 3D space. It is used when no scaling or other distortion is needed. The following constructors are supported:
    • Placement() - empty constructor
    • Placement(Placement) - copy constructor
    • Placement(Matrix) - 4D matrix consisting of rotation and translation
    • Placement(Base, Rotation) - define position and rotation
    • Placement(Base, Rotation,Center) - define position and rotation with center
    • Placement(Base, Axis, Angle) - define position and rotation
  • Object.Pos - returns the position part of the placement
  • Object.PropertiesList - returns a list of the properties of an object
  • Object.State - returns the FreeCAD state of an object (ie. if it needs to be recomputed)
  • Object.Type - returns a string describing the type of an object
  • Object.ViewObject - returns the associated View Provider (FreeCADGUI object) of an object
  • Object.getAllDerivedFrom() - Returns all descentences
  • Object.getDocumentationOfProperty() - Return the documentation string of the property of this class.
  • Object.getGroupOfProperty() - Return the name of the group which the property belongs to in this class. The properties sorted in differnt named groups for convenience.
  • Object.getPropertyByName() - Return the value of a named property.
  • Object.getTypeOfProperty() - Return the type of a named property. This can be (Hidden,ReadOnly,Output) or any combination.
  • Object.isDerivedFrom() - Returns true if given type is a father
  • Object.purgeTouched() - Mark the object as unchanged
  • Object.touch() - Mark the object as changed (touched)

View Objects

When the GUI is up, each object in the FreeCAD document has an associated ViewObject, that resides in the FreeCADGui document counterpart. A view object can be retrieved by two ways:

myViewObj = FreeCAD.ActiveDocument.myObjectName.ViewObject
myViewObj = FreeCADGui.ActiveDocument.myObjectName
  • ViewObject.Annotation - the annotation node of a ViewObject
  • ViewObject.BoundingBox - the bounding box
  • ViewObject.Content - returns an XML representation of a ViewObject's properties
  • ViewObject.DisplayMode - returns the current display mode
  • ViewObject.IV - returns an Inventor representation of the ViewObject
  • ViewObject.Object - returns the associated FreeCAD Document Object of this ViewObject
  • ViewObject.PropertiesList - returns a list of properties of this ViewObject
  • ViewObject.RootNode - returns the Inventor node of this ViewObject
  • ViewObject.Selectable - returns True if the object is selectable
  • ViewObject.Type - returns the type of this ViewObject
  • ViewObject.Visibility - returns True if the viewObject is visible
  • ViewObject.getAllDerivedFrom() - Returns all descentences
  • ViewObject.getDocumentationOfProperty() - Return the documentation string of the property of this class.
  • ViewObject.getGroupOfProperty() - Return the name of the group which the property belongs to in this class. The properties sorted in differnt named groups for convenience.
  • ViewObject.getPropertyByName() - Return the value of a named property.
  • ViewObject.getTypeOfProperty() - Return the type of a named property. This can be (Hidden,ReadOnly,Output) or any combination.
  • ViewObject.hide() - Hides the object
  • ViewObject.isDerivedFrom() - Returns true if given type is a father
  • ViewObject.isVisible() - Check if the object is visible
  • ViewObject.listDisplayModes() - Show a list of all display modes
  • ViewObject.setTransformation() - Set a transformation on the Inventor node
  • ViewObject.show() - Show the object
  • ViewObject.toString() - Return a string representation of the Inventor node
  • ViewObject.update() - Update the view representation of the object